Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ImmutableMultimap<K,V>

    java.lang.Object
      com.google.common.collect.ImmutableMultimap<K,V>

All Implemented Interfaces:
  Multimap<K,V>, Serializable

Direct Known Subclasses:
  ImmutableListMultimap, ImmutableSetMultimap

    public abstract class ImmutableMultimap<K,V>

extends Object
implements Multimap<K,V>, Serializable

An immutable `Multimap`. Does not permit null keys or values.

Unlike `Multimaps.unmodifiableMultimap(Multimap)`, which is a view of a separate multimap which can still change, an instance of `ImmutableMultimap` contains its own data and will never change. `ImmutableMultimap` is convenient for `public static final` multimaps ("constant multimaps") and also lets you easily make a "defensive copy" of a multimap provided to your class by a caller.

Note: Although this class is not final, it cannot be subclassed as it has no public or protected constructors. Thus, instances of this class are guaranteed to be immutable.

Author:
  Jared Levy
See Also:
  Serialized Form

Nested Class Summary
`static class` | `ImmutableMultimap.Builder<K,V>` A builder for creating immutable multimap instances, especially `public static final` multimaps ("constant multimaps").

Method Summary
`ImmutableMap<K,Collection<V>>` | `asMap()` Returns an immutable map that associates each key with its corresponding values in the multimap.
`static
`<K,V> ImmutableMultimap.Builder<K,V>`
` | `builder()` Returns a new builder.
`void` | `clear()` Guaranteed to throw an exception and leave the multimap unmodified.
`boolean` | `containsEntry(Object key, Object value)` Returns `true` if the multimap contains the specified key-value pair.
`boolean` | `containsKey(Object key)` Returns `true` if the multimap contains any values for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if the multimap contains the specified value for any key.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `copyOf(Multimap<? extends K,? extends V> multimap)` Returns an immutable multimap containing the same mappings as `multimap`.
`ImmutableCollection<Map.Entry<K,V>>` | `entries()` Returns an immutable collection of all key-value pairs in the multimap.
`boolean` | `equals(Object object)` Indicates whether some other object is "equal to" this one.
`abstract ImmutableCollection<V>` | `get(K key)` Returns an immutable collection of the values for the given key.
`int` | `hashCode()` Returns a hash code value for the object.
`boolean` | `isEmpty()` Returns `true` if the multimap contains no key-value pairs.
`ImmutableMultiset<K>` | `keys()` Returns a collection, which may contain duplicates, of all keys.
`ImmutableSet<K>` | `keySet()` Returns an immutable set of the distinct keys in this multimap.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of()` Returns an empty multimap.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1)` Returns an immutable multimap containing a single entry.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2)` Returns an immutable multimap containing the given entries, in order.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3)` Returns an immutable multimap containing the given entries, in order.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4)` Returns an immutable multimap containing the given entries, in order.
`static
`<K,V> ImmutableMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4, K k5, V v5)` Returns an immutable multimap containing the given entries, in order.
`boolean` | `put(K key, V value)` Guaranteed to throw an exception and leave the multimap unmodified.
`boolean` | `putAll(K key, Iterable<? extends V> values)` Guaranteed to throw an exception and leave the multimap unmodified.
`boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Guaranteed to throw an exception and leave the multimap unmodified.
`boolean` | `remove(Object key, Object value)` Guaranteed to throw an exception and leave the multimap unmodified.
`ImmutableCollection<V>` | `removeAll(Object key)` Guaranteed to throw an exception and leave the multimap unmodified.
`ImmutableCollection<V>` | `replaceValues(K key, Iterable<? extends V> values)` Guaranteed to throw an exception and leave the multimap unmodified.
`int` | `size()` Returns the number of key-value pairs in the multimap.
`String` | `toString()` Returns a string representation of the object.
`ImmutableCollection<V>` | `values()` Returns an immutable collection of the values in this multimap.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### of

    public static <K,V> ImmutableMultimap<K,V> of()

  Returns an empty multimap.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1)

  Returns an immutable multimap containing a single entry.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1,
                                                  K k2,
                                                  V v2)

  Returns an immutable multimap containing the given entries, in order.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1,
                                                  K k2,
                                                  V v2,
                                                  K k3,
                                                  V v3)

  Returns an immutable multimap containing the given entries, in order.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1,
                                                  K k2,
                                                  V v2,
                                                  K k3,
                                                  V v3,
                                                  K k4,
                                                  V v4)

  Returns an immutable multimap containing the given entries, in order.

### of

    public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                                  V v1,
                                                  K k2,
                                                  V v2,
                                                  K k3,
                                                  V v3,
                                                  K k4,
                                                  V v4,
                                                  K k5,
                                                  V v5)

  Returns an immutable multimap containing the given entries, in order.

### builder

    public static <K,V> ImmutableMultimap.Builder<K,V> builder()

  Returns a new builder. The generated builder is equivalent to the builder created by the `ImmutableMultimap.Builder` constructor.

### copyOf

    public static <K,V> ImmutableMultimap<K,V> copyOf(Multimap<? extends K,? extends V> multimap)

  Returns an immutable multimap containing the same mappings as `multimap`. The generated multimap's key and value orderings correspond to the iteration ordering of the `multimap.asMap()` view.

  Note: Despite what the method name suggests, if `multimap` is an `ImmutableMultimap`, no copy will actually be performed, and the given multimap itself will be returned.

  Throws:
    `NullPointerException` - if any key or value in `multimap` is null

### removeAll

    public ImmutableCollection<V> removeAll(Object key)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `removeAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entries to remove from the multimap
  Returns:
    the collection of removed values, or an empty collection if no values were associated with the provided key. The collection may be modifiable, but updating it will have no effect on the multimap.
  Throws:
    `UnsupportedOperationException` - always

### replaceValues

    public ImmutableCollection<V> replaceValues(K key,
                                                Iterable<? extends V> values)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `replaceValues` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.
  Throws:
    `UnsupportedOperationException` - always

### clear

    public void clear()

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `clear` in interface `Multimap<K,V>`
  Throws:
    `UnsupportedOperationException` - always

### get

    public abstract ImmutableCollection<V> get(K key)

  Returns an immutable collection of the values for the given key. If no mappings in the multimap have the provided key, an empty immutable collection is returned. The values are in the same order as the parameters used to build this multimap.

  Specified by:
    `get` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
  Returns:
    the collection of values that the key maps to

### put

    public boolean put(K key,
                       V value)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `put` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `value` - value to store in the multimap
  Returns:
    `true` if the method increased the size of the multimap, or `false` if the multimap already contained the key-value pair and doesn't allow duplicates
  Throws:
    `UnsupportedOperationException` - always

### putAll

    public boolean putAll(K key,
                          Iterable<? extends V> values)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    `true` if the multimap changed
  Throws:
    `UnsupportedOperationException` - always

### putAll

    public boolean putAll(Multimap<? extends K,? extends V> multimap)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `multimap` - mappings to store in this multimap
  Returns:
    `true` if the multimap changed
  Throws:
    `UnsupportedOperationException` - always

### remove

    public boolean remove(Object key,
                          Object value)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `remove` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entry to remove from the multimap
    `value` - value of entry to remove the multimap
  Returns:
    `true` if the multimap changed
  Throws:
    `UnsupportedOperationException` - always

### containsEntry

    public boolean containsEntry(@Nullable
                                 Object key,
                                 @Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified key-value pair.

  Specified by:
    `containsEntry` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
    `value` - value to search for in multimap

### containsKey

    public boolean containsKey(@Nullable
                               Object key)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains any values for the specified key.

  Specified by:
    `containsKey` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap

### containsValue

    public boolean containsValue(@Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified value for any key.

  Specified by:
    `containsValue` in interface `Multimap<K,V>`
  Parameters:
    `value` - value to search for in multimap

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains no key-value pairs.

  Specified by:
    `isEmpty` in interface `Multimap<K,V>`

### size

    public int size()

  Description copied from interface: `Multimap`
  Returns the number of key-value pairs in the multimap.

  Specified by:
    `size` in interface `Multimap<K,V>`

### equals

    public boolean equals(@Nullable
                          Object object)

  Description copied from class: `java.lang.Object`
  Indicates whether some other object is "equal to" this one.

  The `equals` method implements an equivalence relation on non-null object references:

  - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
  - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
  - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
  - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
  - For any non-null reference value `x`, `x.equals(null)` should return `false`.

  The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

  Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

  Specified by:
    `equals` in interface `Multimap<K,V>`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `object` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Description copied from class: `java.lang.Object`
  Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by `java.util.Hashtable`.

  The general contract of `hashCode` is:

  - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
  - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
  - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables.

  As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

  Specified by:
    `hashCode` in interface `Multimap<K,V>`
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Description copied from class: `java.lang.Object`
  Returns a string representation of the object. In general, the `toString` method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method.

  The `toString` method for class `Object` returns a string consisting of the name of the class of which the object is an instance, the at-sign character ``@`', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of:

  >      getClass().getName() + '@' + Integer.toHexString(hashCode())

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the object.

### keySet

    public ImmutableSet<K> keySet()

  Returns an immutable set of the distinct keys in this multimap. These keys are ordered according to when they first appeared during the construction of this multimap.

  Specified by:
    `keySet` in interface `Multimap<K,V>`
  Returns:
    the collection of distinct keys

### asMap

    public ImmutableMap<K,Collection<V>> asMap()

  Returns an immutable map that associates each key with its corresponding values in the multimap.

  Specified by:
    `asMap` in interface `Multimap<K,V>`
  Returns:
    a map view from a key to its collection of values

### entries

    public ImmutableCollection<Map.Entry<K,V>> entries()

  Returns an immutable collection of all key-value pairs in the multimap. Its iterator traverses the values for the first key, the values for the second key, and so on.

  Specified by:
    `entries` in interface `Multimap<K,V>`
  Returns:
    collection of map entries consisting of key-value pairs

### keys

    public ImmutableMultiset<K> keys()

  Returns a collection, which may contain duplicates, of all keys. The number of times a key appears in the returned multiset equals the number of mappings the key has in the multimap. Duplicate keys appear consecutively in the multiset's iteration order.

  Specified by:
    `keys` in interface `Multimap<K,V>`
  Returns:
    a multiset with keys corresponding to the distinct keys of the multimap and frequencies corresponding to the number of values that each key maps to

### values

    public ImmutableCollection<V> values()

  Returns an immutable collection of the values in this multimap. Its iterator traverses the values for the first key, the values for the second key, and so on.

  Specified by:
    `values` in interface `Multimap<K,V>`
  Returns:
    collection of values, which may include the same value multiple times if it occurs in multiple mappings

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD